## gdu 4.3.3

=== Makefile ===
NAME := gdu
PACKAGE := github.com/dundee/$(NAME)
VERSION := $(shell git describe --tags)
GOFLAGS ?= -buildmode=pie -trimpath -mod=readonly -modcacherw
LDFLAGS := "-s -w -extldflags '-static' \
	-X '$(PACKAGE)/build.Version=$(VERSION)' \
	-X '$(PACKAGE)/build.User=$(shell id -u -n)' \
	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'"

run:
	go run .

build:
	@echo "Version: " $(VERSION)
	mkdir -p dist
	GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -a -ldflags=$(LDFLAGS) -o dist/$(NAME) .

build-all:
	@echo "Version: " $(VERSION)
	-mkdir dist
	-CGO_ENABLED=0 gox \
		-os="darwin windows" \
		-arch="amd64" \
		-output="dist/{{.Dir}}_{{.OS}}_{{.Arch}}" \
		-ldflags=$(LDFLAGS)

	-CGO_ENABLED=0 gox \
		-os="linux freebsd netbsd openbsd" \
		-output="dist/{{.Dir}}_{{.OS}}_{{.Arch}}" \
		-ldflags=$(LDFLAGS)

	cd dist; GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -a -ldflags=$(LDFLAGS) -o gdu_linux_amd64 ..

	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=5 GOARCH=arm go build -ldflags=$(LDFLAGS) -o gdu_linux_armv5l ..
	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=6 GOARCH=arm go build -ldflags=$(LDFLAGS) -o gdu_linux_armv6l ..
	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=7 GOARCH=arm go build -ldflags=$(LDFLAGS) -o gdu_linux_armv7l ..
	cd dist; CGO_ENABLED=0 GOOS=linux GOARCH=arm64 go build -ldflags=$(LDFLAGS) -o gdu_linux_arm64 ..

	cd dist; for file in gdu_linux_* gdu_darwin_* gdu_netbsd_* gdu_openbsd_* gdu_freebsd_*; do tar czf $$file.tgz $$file; done
	cd dist; for file in gdu_windows_*; do zip $$file.zip $$file; done

test:
	go test -v ./...

coverage:
	go test -v -race -coverprofile=coverage.txt -covermode=atomic ./...

coverage-html: coverage
	go tool cover -html=coverage.txt

gobench:
	go test -bench=. ./...

benchmark:
	hyperfine --export-markdown=bench-cold.md \
		--prepare 'sync; echo 3 | sudo tee /proc/sys/vm/drop_caches' \
		'gdu -npc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
    	'diskus -b ~' 'du -hs ~' 'dust -d0 ~'
	hyperfine --export-markdown=bench-warm.md \
		--warmup 5 \
		'gdu -npc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
    	'diskus -b ~' 'du -hs ~' 'dust -d0 ~'

clean:
	-rm coverage.txt
	-rm -r test_dir
	-rm -r dist

clean-uncompressed-dist:
	find dist -type f -not -name '*.tgz' -not -name '*.zip' -delete

.PHONY: run build test coverage coverage-html clean

=== debian/changelog ===
gdu (4.3.3-1) unstable; urgency=medium

  * Initial release (Closes: 980350)

 -- Daniel Milde <daniel@milde.cz>  Wed, 27 Jan 2021 10:23:15 +0200

=== debian/rules ===
#!/usr/bin/make -f

DH_GOPKG = github.com/dundee/gdu
PKD  = $(abspath $(dir $(MAKEFILE_LIST)))
VERSION ?= $(shell dpkg-parsechangelog -l$(PKD)/changelog | perl -ne 'print $$1 if m{^Version:\s*([\d\.]+)}')

PACKAGES := $(shell go list ./...)
GOLDFLAGS ?= \
	-X '$(DH_GOPKG)/build.Version=$(VERSION)' \
	-X '$(DH_GOPKG)/build.User=$(shell id -u -n)' \
	-X '$(DH_GOPKG)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_build:
	dh_auto_build -- \
            -ldflags "$(GOLDFLAGS)"

## gdu 4.4.1

=== debian/changelog ===
gdu (4.4.1-1) unstable; urgency=medium

  * fixed tests for chrooted environments

 -- Daniel Milde <daniel@milde.cz>  Fri, 05 Feb 2021 20:19:52 +0100

## gdu 4.6.1

=== Makefile ===
--- 
+++ 
@@ -6,6 +6,8 @@
 	-X '$(PACKAGE)/build.Version=$(VERSION)' \
 	-X '$(PACKAGE)/build.User=$(shell id -u -n)' \
 	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'"
+
+all: build-all gdu.1
 
 run:
 	go run .
@@ -39,6 +41,12 @@
 	cd dist; for file in gdu_linux_* gdu_darwin_* gdu_netbsd_* gdu_openbsd_* gdu_freebsd_*; do tar czf $$file.tgz $$file; done
 	cd dist; for file in gdu_windows_*; do zip $$file.zip $$file; done
 
+gdu.1: gdu.1.md
+	pandoc gdu.1.md -s -t man > gdu.1
+
+show-man:
+	pandoc gdu.1.md -s -t man | man -l -
+
 test:
 	go test -v ./...

=== debian/changelog ===
gdu (4.6.1-1) unstable; urgency=medium

  * added flag -x for not crossing filesystem boundaries
  * show flags (error, empty, symlink, e.g.)
  * detect hard links
  * show modal on deletion error
  * more readable colors

 -- Daniel Milde <daniel@milde.cz>  Mon, 15 Feb 2021 17:29:56 +0100

gdu (4.4.1-2) unstable; urgency=medium

  * fixed ldflags for build to be reproducible

 -- Daniel Milde <daniel@milde.cz>  Fri, 12 Feb 2021 20:28:11 +0100

## gdu 4.6.3

=== Makefile ===
--- 
+++ 
@@ -2,10 +2,10 @@
 PACKAGE := github.com/dundee/$(NAME)
 VERSION := $(shell git describe --tags)
 GOFLAGS ?= -buildmode=pie -trimpath -mod=readonly -modcacherw
-LDFLAGS := "-s -w -extldflags '-static' \
+LDFLAGS := -s -w -extldflags '-static' \
 	-X '$(PACKAGE)/build.Version=$(VERSION)' \
 	-X '$(PACKAGE)/build.User=$(shell id -u -n)' \
-	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'"
+	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'
 
 all: build-all gdu.1
 
@@ -15,7 +15,7 @@
 build:
 	@echo "Version: " $(VERSION)
 	mkdir -p dist
-	GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -a -ldflags=$(LDFLAGS) -o dist/$(NAME) .
+	GOFLAGS="$(GOFLAGS)" go build -a -ldflags="$(LDFLAGS)" -o dist/$(NAME) .
 
 build-all:
 	@echo "Version: " $(VERSION)
@@ -24,19 +24,19 @@
 		-os="darwin windows" \
 		-arch="amd64" \
 		-output="dist/{{.Dir}}_{{.OS}}_{{.Arch}}" \
-		-ldflags=$(LDFLAGS)
+		-ldflags="$(LDFLAGS)"
 
 	-CGO_ENABLED=0 gox \
 		-os="linux freebsd netbsd openbsd" \
 		-output="dist/{{.Dir}}_{{.OS}}_{{.Arch}}" \
-		-ldflags=$(LDFLAGS)
+		-ldflags="$(LDFLAGS)"
 
-	cd dist; GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -a -ldflags=$(LDFLAGS) -o gdu_linux_amd64 ..
+	cd dist; GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -a -ldflags="$(LDFLAGS)" -o gdu_linux_amd64 ..
 
-	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=5 GOARCH=arm go build -ldflags=$(LDFLAGS) -o gdu_linux_armv5l ..
-	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=6 GOARCH=arm go build -ldflags=$(LDFLAGS) -o gdu_linux_armv6l ..
-	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=7 GOARCH=arm go build -ldflags=$(LDFLAGS) -o gdu_linux_armv7l ..
-	cd dist; CGO_ENABLED=0 GOOS=linux GOARCH=arm64 go build -ldflags=$(LDFLAGS) -o gdu_linux_arm64 ..
+	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=5 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv5l ..
+	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=6 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv6l ..
+	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=7 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv7l ..
+	cd dist; CGO_ENABLED=0 GOOS=linux GOARCH=arm64 go build -ldflags="$(LDFLAGS)" -o gdu_linux_arm64 ..
 
 	cd dist; for file in gdu_linux_* gdu_darwin_* gdu_netbsd_* gdu_openbsd_* gdu_freebsd_*; do tar czf $$file.tgz $$file; done
 	cd dist; for file in gdu_windows_*; do zip $$file.zip $$file; done

=== debian/changelog ===
gdu (4.6.3-1) unstable; urgency=medium

  * usage test is not valid on all architectures
  * g/G key bindings added to help

 -- Daniel Milde <daniel@milde.cz>  Thu, 18 Feb 2021 11:28:56 +0100

gdu (4.6.2-1) unstable; urgency=medium

  * keep background color of the terminal
  * delete files in separate thread
  * fixed data race in flag propagation

 -- Daniel Milde <daniel@milde.cz>  Tue, 16 Feb 2021 21:09:06 +0100

=== debian/control ===
Source: gdu
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Daniel Milde <daniel@milde.cz>
Section: admin
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-any,
               golang-github-gdamore-tcell.v2-dev,
               golang-github-mattn-go-isatty-dev,
               golang-github-rivo-tview-dev (>= 0.0~git20210122),
               golang-github-spf13-cobra-dev,
               golang-github-fatih-color-dev,
               golang-github-stretchr-testify-dev
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/go-team/packages/gdu
Vcs-Git: https://salsa.debian.org/go-team/packages/gdu.git
Homepage: https://github.com/dundee/gdu
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/dundee/gdu

Package: gdu
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: Pretty fast disk usage analyzer
 Disk usage analyzer with console interface written in Go.
 Intended primarily for SSD disks where it can fully
 utilize parallel processing. However HDDs work as well, but
 the performance gain is not so huge.

=== debian/rules ===
#!/usr/bin/make -f

DH_GOPKG = github.com/dundee/gdu
VERSION ?= $(shell dpkg-parsechangelog -SVersion)

GOLDFLAGS ?= \
	-s -w \
	-X '$(DH_GOPKG)/build.Version=$(VERSION)' \
	-X '$(DH_GOPKG)/build.User=debian' \
	-X '$(DH_GOPKG)/build.Time=$(shell TZ=Etc/UTC date +'%F_%T' -d @$(SOURCE_DATE_EPOCH))'

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_build:
	dh_auto_build -- -ldflags "$(GOLDFLAGS)"

## gdu 5.8.1

=== debian/changelog ===
gdu (5.8.1-2~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Daniel Milde <daniel@milde.cz>  Fri, 01 Oct 2021 14:56:35 +0200

gdu (5.8.1-2) unstable; urgency=medium

  * standards bumped to 4.6.0

 -- Daniel Milde <daniel@milde.cz>  Mon, 27 Sep 2021 20:36:47 +0200

gdu (5.8.1-1) unstable; urgency=medium

  * stop GC while running analysis
  * do not build PIE as it breaks build on mips

 -- Daniel Milde <daniel@milde.cz>  Mon, 27 Sep 2021 11:59:37 +0200

gdu (5.7.0-1) unstable; urgency=medium

  * sort devices by name and used size
  * show total usage and sorting on devices list
  * suspend the application instead of stopping

 -- Daniel Milde <daniel@milde.cz>  Sun, 19 Sep 2021 22:09:57 +0200

gdu (5.6.2-1) unstable; urgency=medium

  [ Daniel Milde ]
  * upgrade to go 1.16
  * use 3x number of cores
  * run gc when the analysis is done
  * show content of file
  * disable CGO for all builds
  * do not allow some actions while scanning/deleting/confirming
  * keep selected dir when using enter for return
  * use GOMAXPROCS
  * use channel instead of mutex

  [ Jeff Cook ]
  * Keep cursor on selection when swapping between apparent/actual size.

  [ knyazevoe ]
  * added maxprocs flag, that sets GOMAXPROCS

  [ Leonidas Spyropoulos ]
  * Skip failing tests on single core CPUs

  [ Daniel Milde ]
  * added possibility to ignore hidden dirs and ignore dirs by regular pattern
  * main package moved to cmd/gdu
  * show file count [BC break]

  [ huangnauh ]
  * fix: update tview to fix crash

  [ Daniel Milde ]
  * replace std log module with sirupsen/logrus
  * show info about selected item

  [ zhangsean ]
  * Feature: Empty selected file or directory
  * Improve some coding.

  [ Daniel Milde ]
  * export analysis to file as JSON
  * read analysis from file

  [ jtagcat ]
  * tui help: 'Go to' instead of 'Select' for open.
  * helpText: refer to up/down with k/j, past: k, j

  [ Daniel Milde ]
  * help info structured
  * fix compatibility with ncdu export format
  * fixed not showing colors for export
  * added thousand separator to item count number
  * detect correctly NFS mounts
  * search items by name
  * feat: print current directory path and quit on `Q` key
  * spawn shell in current directory on pressing `b`
  * adjust the height of the help box to the size of the screen
  * feat: show last mtime by pressing `m` and sort by mtime by pressing `M`
  * import/export mtime

  [ Daniel Milde ]
  * fix: check if currentDir is set
  * fix: check if currentDir is set when selecting item
  * fix: set ui.currentDir at last

 -- Daniel Milde <daniel@milde.cz>  Sat, 28 Aug 2021 00:48:18 +0200

=== debian/control ===
Source: gdu
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Daniel Milde <daniel@milde.cz>,
Section: admin
Testsuite: autopkgtest-pkg-go
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               golang-1.17,
               golang-github-fatih-color-dev,
               golang-github-gdamore-tcell.v2-dev,
               golang-github-mattn-go-isatty-dev,
               golang-github-rivo-tview-dev (>= 0.0~git20210122),
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-stretchr-testify-dev,
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/go-team/packages/gdu
Vcs-Git: https://salsa.debian.org/go-team/packages/gdu.git
Homepage: https://github.com/dundee/gdu
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/dundee/gdu/v5

Package: gdu
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Built-Using: ${misc:Built-Using},
Description: Pretty fast disk usage analyzer
 Disk usage analyzer with console interface written in Go.
 Intended primarily for SSD disks where it can fully
 utilize parallel processing. However HDDs work as well, but
 the performance gain is not so huge.

## gdu 5.9.0

=== debian/changelog ===
gdu (5.9.0-1) unstable; urgency=medium

  * added option to show total usage for given path #96
  * added option to read ignore patterns from file
  * refactor: struct fields aligned correctly

 -- Daniel Milde <daniel@milde.cz>  Sat, 23 Oct 2021 15:16:31 +0200

gdu (5.8.1-3) unstable; urgency=medium

  * use go 1.16

 -- Daniel Milde <daniel@milde.cz>  Fri, 15 Oct 2021 14:30:04 +0200

## gdu 5.10.0

=== debian/changelog ===
gdu (5.10.0-1) unstable; urgency=medium

  [ Daniel Milde ]
  * fix: correct install command for go
  * refactor: use strconv instead of fmt

  [ Jay R. Wren ]
  * add ino, hlnkc to json
  * tests

  [ Daniel Milde ]
  * stop UI when spawning shell on Windows
  * test execute
  * show info about hard-linked files
  * added possibility to move around while info window is opened

  [ Jeremy Neville ]
  * Info modal closes with "i"

  [ Daniel Milde ]
  * fix: do not show help if file info is shown

 -- Daniel Milde <daniel@milde.cz>  Thu, 11 Nov 2021 18:04:36 +0100

## gdu 5.10.1

=== debian/changelog ===
gdu (5.10.1-1) unstable; urgency=medium

  * convert path to absolute before checking crossing mountpoints

 -- Daniel Milde <daniel@milde.cz>  Tue, 23 Nov 2021 16:09:23 +0100

## gdu 5.11.0

=== Makefile ===
NAME := gdu
MAJOR_VER := v5
PACKAGE := github.com/dundee/$(NAME)/$(MAJOR_VER)
CMD_GDU := cmd/gdu
VERSION := $(shell git describe --tags 2>/dev/null)
DATE := $(shell date +'%Y-%m-%d')
GOFLAGS ?= -buildmode=pie -trimpath -mod=readonly -modcacherw
LDFLAGS := -s -w -extldflags '-static' \
	-X '$(PACKAGE)/build.Version=$(VERSION)' \
	-X '$(PACKAGE)/build.User=$(shell id -u -n)' \
	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'

all: clean build-all man clean-uncompressed-dist shasums

run:
	go run $(PACKAGE)/$(CMD_GDU)

build:
	@echo "Version: " $(VERSION)
	mkdir -p dist
	GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -ldflags="$(LDFLAGS)" -o dist/$(NAME) $(PACKAGE)/$(CMD_GDU)

build-all:
	@echo "Version: " $(VERSION)
	-mkdir dist
	-CGO_ENABLED=0 gox \
		-os="darwin windows" \
		-arch="amd64" \
		-output="dist/gdu_{{.OS}}_{{.Arch}}" \
		-ldflags="$(LDFLAGS)" \
		$(PACKAGE)/$(CMD_GDU)

	-CGO_ENABLED=0 gox \
		-os="linux freebsd netbsd openbsd" \
		-output="dist/gdu_{{.OS}}_{{.Arch}}" \
		-ldflags="$(LDFLAGS)" \
		$(PACKAGE)/$(CMD_GDU)

	cd dist; GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -ldflags="$(LDFLAGS)" -o gdu_linux_amd64 $(PACKAGE)/$(CMD_GDU)

	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=5 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv5l $(PACKAGE)/$(CMD_GDU)
	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=6 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv6l $(PACKAGE)/$(CMD_GDU)
	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=7 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv7l $(PACKAGE)/$(CMD_GDU)
	cd dist; CGO_ENABLED=0 GOOS=linux GOARCH=arm64 go build -ldflags="$(LDFLAGS)" -o gdu_linux_arm64 $(PACKAGE)/$(CMD_GDU)

	cd dist; for file in gdu_linux_* gdu_darwin_* gdu_netbsd_* gdu_openbsd_* gdu_freebsd_*; do tar czf $$file.tgz $$file; done
	cd dist; for file in gdu_windows_*; do zip $$file.zip $$file; done

gdu.1: gdu.1.md
	sed 's/{{date}}/$(DATE)/g' gdu.1.md > gdu.1.date.md
	pandoc gdu.1.date.md -s -t man > gdu.1
	rm -f gdu.1.date.md

man: gdu.1
	cp gdu.1 dist
	cd dist; tar czf gdu.1.tgz gdu.1

show-man:
	sed 's/{{date}}/$(DATE)/g' gdu.1.md > gdu.1.date.md
	pandoc gdu.1.date.md -s -t man | man -l -

test:
	go test -v ./...

coverage:
	go test -v -race -coverprofile=coverage.txt -covermode=atomic ./...

coverage-html: coverage
	go tool cover -html=coverage.txt

gobench:
	go test -bench=. $(PACKAGE)/pkg/analyze

benchmark:
	hyperfine --export-markdown=bench-cold.md \
		--prepare 'sync; echo 3 | sudo tee /proc/sys/vm/drop_caches' \
		'gdu -npc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
		'diskus ~' 'du -hs ~' 'dust -d0 ~'
	hyperfine --export-markdown=bench-warm.md \
		--warmup 5 \
		'gdu -npc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
		'diskus ~' 'du -hs ~' 'dust -d0 ~'

clean:
	go mod tidy
	-rm coverage.txt
	-rm -r test_dir
	-rm -r dist

clean-uncompressed-dist:
	find dist -type f -not -name '*.tgz' -not -name '*.zip' -delete

shasums:
	cd dist; sha256sum * > sha256sums.txt
	cd dist; gpg --sign --armor --detach-sign sha256sums.txt

release:
	gh release create -t "gdu $(VERSION)" $(VERSION) ./dist/*

.PHONY: run build test coverage coverage-html clean man

=== debian/changelog ===
gdu (5.11.0-1) unstable; urgency=medium

  * added option to run memory garbage collection during analysis
  * added option to collect profiling data

 -- Daniel Milde <daniel@milde.cz>  Sun, 28 Nov 2021 13:16:00 +0100

## gdu 5.12.1

=== debian/changelog ===
gdu (5.12.1-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.

 -- Daniel Milde <daniel@milde.cz>  Fri, 24 Dec 2021 15:22:00 +0100

gdu (5.12.1-1) unstable; urgency=medium

  [ Daniel Milde ]
  * man page updated
  * benchmarks updated

  [ Leonidas Spyropoulos ]
  * Implement noCross for darwin

  [ Daniel Milde ]
  * device implementation for freebsd and darwin merged
  * fixed processing mount points with space on linux
  * fixed bsd test
  * travis icon removed
  * openbsd and netbsd builds fixed
  * listing devices on netbsd
  * use sys.unix instead of syscall
  * added compilation directives
  * fix: escape file names
  * fix: direct dependency on sys
  * fix: do not pass key when filtering is started
  * doc: small readme rewording

 -- Daniel Milde <daniel@milde.cz>  Sun, 12 Dec 2021 10:41:59 +0100

gdu (5.11.0-1~bpo11+1) bullseye-backports; urgency=medium

  * Rebuild for bullseye-backports.
  * d/changelog for backports
  * debian-branch for backports

 -- Daniel Milde <daniel@milde.cz>  Thu, 02 Dec 2021 20:34:02 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
-               golang-1.17,
                golang-github-fatih-color-dev,
                golang-github-gdamore-tcell.v2-dev,
                golang-github-mattn-go-isatty-dev,
@@ -14,6 +13,7 @@
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,
+               golang-go,
 Standards-Version: 4.6.0
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gdu
 Vcs-Git: https://salsa.debian.org/go-team/packages/gdu.git

## gdu 5.13.2

=== Makefile ===
--- 
+++ 
@@ -74,11 +74,11 @@
 benchmark:
 	hyperfine --export-markdown=bench-cold.md \
 		--prepare 'sync; echo 3 | sudo tee /proc/sys/vm/drop_caches' \
-		'gdu -npc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
+		'gdu -npc ~' 'gdu -gnpc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
 		'diskus ~' 'du -hs ~' 'dust -d0 ~'
 	hyperfine --export-markdown=bench-warm.md \
 		--warmup 5 \
-		'gdu -npc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
+		'gdu -npc ~' 'gdu -gnpc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
 		'diskus ~' 'du -hs ~' 'dust -d0 ~'
 
 clean:

=== debian/changelog ===
gdu (5.13.2-1) unstable; urgency=medium

  [ Daniel Milde ]
  * refactor: interfaces moved away from implementations
  * fix: unkeyd fields
  * doc: gdu migrated to community in ArchLinux
  * refactor: size constants renamed
  * added option `--si` for showing sizes with decimal SI prefixes
  * fix: register pprof endpoints only when requested
  * refactor: enabling/disabling GC moved to analyzer
  * balance speed and memory usage

  [ Georgi Georgiev ]
  * Make the bar graph meaningful in large directories
  * Make the relative-size display the user's choice
  * Fix the tests

  [ Daniel Milde ]
  * refactor: we only read from chan
  * test: more tests for relative bar
  * test: test closing help using question mark and
    moving around when info page is opened
  * fix: recreate doneChan for every scan
  * fix: check value before waiting
  * refactor: return concrete implementation
  * refactor: proper parameter name

  [ Georgi Georgiev ]
  * Properly count only the first hard link size on a rescan

  [ Daniel Milde ]
  * fix: do not panic if path does not start with slash
  * test: added more file and actions tests
  * fix(devices): go back to devices list

 -- Daniel Milde <daniel@milde.cz>  Sat, 19 Feb 2022 18:01:48 +0100

=== debian/control ===
--- 
+++ 
@@ -9,6 +9,7 @@
                golang-github-fatih-color-dev,
                golang-github-gdamore-tcell.v2-dev,
                golang-github-mattn-go-isatty-dev,
+               golang-github-pbnjay-memory-dev,
                golang-github-rivo-tview-dev (>= 0.0~git20210122),
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,

=== debian/rules ===
#!/usr/bin/make -f

GOPKG = github.com/dundee/gdu/v5
VERSION ?= $(shell dpkg-parsechangelog -SVersion)

DH_GOLANG_BUILDPKG := github.com/dundee/gdu/v5/cmd/gdu
CGO_ENABLED := 0

GO_LDFLAGS += -X '$(GOPKG)/build.Version=$(VERSION)'
GO_LDFLAGS += -X '$(GOPKG)/build.User=debian' 
GO_LDFLAGS += -X '$(GOPKG)/build.Time=$(shell TZ=Etc/UTC date +'%F_%T' -d @$(SOURCE_DATE_EPOCH))'

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang

override_dh_auto_install:
	dh_auto_install -- --no-source

override_dh_auto_build:
	dh_auto_build -O--buildsystem=golang -- -ldflags "$(GO_LDFLAGS)"

## gdu 5.20.0

=== Makefile ===
--- 
+++ 
@@ -3,28 +3,49 @@
 PACKAGE := github.com/dundee/$(NAME)/$(MAJOR_VER)
 CMD_GDU := cmd/gdu
 VERSION := $(shell git describe --tags 2>/dev/null)
+NAMEVER := $(NAME)-$(subst v,,$(VERSION))
 DATE := $(shell date +'%Y-%m-%d')
 GOFLAGS ?= -buildmode=pie -trimpath -mod=readonly -modcacherw
+GOFLAGS_STATIC ?= -trimpath -mod=readonly -modcacherw
 LDFLAGS := -s -w -extldflags '-static' \
 	-X '$(PACKAGE)/build.Version=$(VERSION)' \
 	-X '$(PACKAGE)/build.User=$(shell id -u -n)' \
 	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'
 
-all: clean build-all man clean-uncompressed-dist shasums
+all: clean tarball build-all man clean-uncompressed-dist shasums
 
 run:
 	go run $(PACKAGE)/$(CMD_GDU)
+
+vendor: go.mod go.sum
+	go mod vendor
+
+tarball: vendor
+	-mkdir dist
+	tar czf dist/$(NAMEVER).tgz --transform "s,^,$(NAMEVER)/," --exclude dist --exclude test_dir --exclude coverage.txt *
 
 build:
 	@echo "Version: " $(VERSION)
 	mkdir -p dist
 	GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -ldflags="$(LDFLAGS)" -o dist/$(NAME) $(PACKAGE)/$(CMD_GDU)
 
+build-static:
+	@echo "Version: " $(VERSION)
+	mkdir -p dist
+	GOFLAGS="$(GOFLAGS_STATIC)" CGO_ENABLED=0 go build -ldflags="$(LDFLAGS)" -o dist/$(NAME) $(PACKAGE)/$(CMD_GDU)
+
 build-all:
 	@echo "Version: " $(VERSION)
 	-mkdir dist
 	-CGO_ENABLED=0 gox \
-		-os="darwin windows" \
+		-os="darwin" \
+		-arch="amd64 arm64" \
+		-output="dist/gdu_{{.OS}}_{{.Arch}}" \
+		-ldflags="$(LDFLAGS)" \
+		$(PACKAGE)/$(CMD_GDU)
+
+	-CGO_ENABLED=0 gox \
+		-os="windows" \
 		-arch="amd64" \
 		-output="dist/gdu_{{.OS}}_{{.Arch}}" \
 		-ldflags="$(LDFLAGS)" \
@@ -37,13 +58,15 @@
 		$(PACKAGE)/$(CMD_GDU)
 
 	cd dist; GOFLAGS="$(GOFLAGS)" CGO_ENABLED=0 go build -ldflags="$(LDFLAGS)" -o gdu_linux_amd64 $(PACKAGE)/$(CMD_GDU)
+	cd dist; GOFLAGS="$(GOFLAGS_STATIC)" CGO_ENABLED=0 go build -ldflags="$(LDFLAGS)" -o gdu_linux_amd64_static $(PACKAGE)/$(CMD_GDU)
 
 	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=5 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv5l $(PACKAGE)/$(CMD_GDU)
 	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=6 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv6l $(PACKAGE)/$(CMD_GDU)
 	cd dist; CGO_ENABLED=0 GOOS=linux GOARM=7 GOARCH=arm go build -ldflags="$(LDFLAGS)" -o gdu_linux_armv7l $(PACKAGE)/$(CMD_GDU)
 	cd dist; CGO_ENABLED=0 GOOS=linux GOARCH=arm64 go build -ldflags="$(LDFLAGS)" -o gdu_linux_arm64 $(PACKAGE)/$(CMD_GDU)
+	cd dist; CGO_ENABLED=0 GOOS=android GOARCH=arm64 go build -ldflags="$(LDFLAGS)" -o gdu_android_arm64 $(PACKAGE)/$(CMD_GDU)
 
-	cd dist; for file in gdu_linux_* gdu_darwin_* gdu_netbsd_* gdu_openbsd_* gdu_freebsd_*; do tar czf $$file.tgz $$file; done
+	cd dist; for file in gdu_linux_* gdu_darwin_* gdu_netbsd_* gdu_openbsd_* gdu_freebsd_* gdu_android_*; do tar czf $$file.tgz $$file; done
 	cd dist; for file in gdu_windows_*; do zip $$file.zip $$file; done
 
 gdu.1: gdu.1.md
@@ -60,10 +83,10 @@
 	pandoc gdu.1.date.md -s -t man | man -l -
 
 test:
-	go test -v ./...
+	gotestsum
 
 coverage:
-	go test -v -race -coverprofile=coverage.txt -covermode=atomic ./...
+	gotestsum -- -race -coverprofile=coverage.txt -covermode=atomic ./...
 
 coverage-html: coverage
 	go tool cover -html=coverage.txt
@@ -85,6 +108,7 @@
 	go mod tidy
 	-rm coverage.txt
 	-rm -r test_dir
+	-rm -r vendor
 	-rm -r dist
 
 clean-uncompressed-dist:
@@ -97,4 +121,7 @@
 release:
 	gh release create -t "gdu $(VERSION)" $(VERSION) ./dist/*
 
-.PHONY: run build test coverage coverage-html clean man
+install-dev-dependencies:
+	go install gotest.tools/gotestsum@latest
+
+.PHONY: run build build-static build-all test gobench benchmark coverage coverage-html clean clean-uncompressed-dist man show-man release

=== debian/changelog ===
gdu (5.20.0-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Milde <daniel@milde.cz>  Sun, 23 Oct 2022 21:31:16 +0200

gdu (5.19.0-1) unstable; urgency=medium

  * feat: upgrade all dependencies
  * feat: bump go version to 1.18
  * feat: format negative numbers correctly closes #178
  * test: export formatting
  * feat: try to read config from ~/.config/gdu/gdu.yaml first
  * docs: config file default locations

 -- Daniel Milde <daniel@milde.cz>  Wed, 28 Sep 2022 21:53:32 +0200

gdu (5.18.1-1) unstable; urgency=medium

  * feat: shorten current item path to 70 chars #172
  * feat: configuration option for setting maximum length of the path for current item in the progress modal
  * feat: show time in progress modal
  * fix: two more lines for progress modal #172
  * fix: readded --config-file flag
  * fix: read non-default config file properly
  * fix: correct config file option regex

 -- Daniel Milde <daniel@milde.cz>  Thu, 22 Sep 2022 23:04:44 +0200

gdu (5.17.1-1) unstable; urgency=medium

  [ Daniel Milde ]
  * fix(tests): access to updateDraws behind mutex
  * refactor: SignalGroup instead of chan
  * fix: add progressDoneChan
  * chore: update golangci-lint to v3
  * ci: added statically linked binary for linux/amd64

  [ Edward Betts ]
  * Correct spelling mistakes

  [ Steven Conaway ]
  * Add darwin@arm64

  [ Daniel Milde ]
  * feat: sort items by name if usage/size/count is the same

  [ Anna “CyberTailor” ]
  * ci: generate release tarballs

  [ Riatre Foo ]
  * fix: honor --summarize when reading analysis

  [ Phani Rithvij ]
  * upgrade dependencies

  [ Daniel Milde ]
  * refactor: correct ordering
  * feat: natural sorting of names
  * fix: correct sorting for non-interactive and export modes
  * feat: show sizes as raw numbers without prefixes
  * docs: flags updated
  * refactor: extract common logic for BSD
  * refactor: split keyPressed

  [ mcoret ]
  * Update dir_other.go

  [ Daniel Milde ]
  * ci: binary for Android
  * test: run 0 perm tests only for Linux
  * fix: mount output format fixes #159
  * feat: better error message
  * test: run zfs test only on freebsd
  * fix: panic on analyzing mount multiple times
  * feat: initial mouse support closes #163
  * chore: ignore vendor dir
  * feat: use configuration file
  * fix: file name
  * docs: man page updated
  * fix: check error
  * test: use gotestsum for running tests
  * refactor: use only yaml for reading/writing config file
  * feat: added possibility to change text color and
    background color of the selected row fixes #168
  * docs: order of sections fixed
  * fix: nul log file for Windows fixes #171
  * fix: increase the vertical size of the progress modal fixes #172
  * d/control: added dependency on golang-gopkg-yaml.v3-dev

 -- Daniel Milde <daniel@milde.cz>  Tue, 13 Sep 2022 00:14:32 +0200

## gdu 5.21.0

=== debian/changelog ===
gdu (5.21.0-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Milde <daniel@milde.cz>  Fri, 06 Jan 2023 16:45:44 +0100

## gdu 5.22.0

=== Makefile ===
--- 
+++ 
@@ -11,6 +11,10 @@
 	-X '$(PACKAGE)/build.Version=$(VERSION)' \
 	-X '$(PACKAGE)/build.User=$(shell id -u -n)' \
 	-X '$(PACKAGE)/build.Time=$(shell LC_ALL=en_US.UTF-8 date)'
+TAR := tar
+ifeq ($(shell uname -s),Darwin)
+	TAR := gtar # brew install gnu-tar
+endif
 
 all: clean tarball build-all man clean-uncompressed-dist shasums
 
@@ -22,7 +26,7 @@
 
 tarball: vendor
 	-mkdir dist
-	tar czf dist/$(NAMEVER).tgz --transform "s,^,$(NAMEVER)/," --exclude dist --exclude test_dir --exclude coverage.txt *
+	$(TAR) czf dist/$(NAMEVER).tgz --transform "s,^,$(NAMEVER)/," --exclude dist --exclude test_dir --exclude coverage.txt *
 
 build:
 	@echo "Version: " $(VERSION)

=== debian/changelog ===
gdu (5.22.0-1) unstable; urgency=medium

  * New upstream release

 -- Daniel Milde <daniel@milde.cz>  Sun, 26 Feb 2023 21:14:58 +0100

=== debian/control ===
--- 
+++ 
@@ -8,6 +8,7 @@
                dh-golang,
                golang-github-fatih-color-dev,
                golang-github-gdamore-tcell.v2-dev,
+               golang-github-maruel-natural-dev,
                golang-github-mattn-go-isatty-dev,
                golang-github-pbnjay-memory-dev,
                golang-github-rivo-tview-dev (>= 0.0~git20210122),
@@ -15,7 +16,8 @@
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,
                golang-go,
-Standards-Version: 4.6.0
+               golang-gopkg-yaml.v3-dev,
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/go-team/packages/gdu
 Vcs-Git: https://salsa.debian.org/go-team/packages/gdu.git
 Homepage: https://github.com/dundee/gdu

=== debian/tests/control ===
Tests: scan version
Depends: @,

## gdu 5.25.0

=== Makefile ===
--- 
+++ 
@@ -99,14 +99,18 @@
 	go test -bench=. $(PACKAGE)/pkg/analyze
 
 benchmark:
+	sudo cpupower frequency-set -g performance
 	hyperfine --export-markdown=bench-cold.md \
 		--prepare 'sync; echo 3 | sudo tee /proc/sys/vm/drop_caches' \
+		--ignore-failure \
 		'gdu -npc ~' 'gdu -gnpc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
-		'diskus ~' 'du -hs ~' 'dust -d0 ~'
+		'diskus ~' 'du -hs ~' 'dust -d0 ~' 'pdu ~'
 	hyperfine --export-markdown=bench-warm.md \
 		--warmup 5 \
+		--ignore-failure \
 		'gdu -npc ~' 'gdu -gnpc ~' 'dua ~' 'duc index ~' 'ncdu -0 -o /dev/null ~' \
-		'diskus ~' 'du -hs ~' 'dust -d0 ~'
+		'diskus ~' 'du -hs ~' 'dust -d0 ~' 'pdu ~'
+	sudo cpupower frequency-set -g schedutil
 
 clean:
 	go mod tidy

=== debian/control ===
--- 
+++ 
@@ -7,11 +7,11 @@
 Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-github-fatih-color-dev,
-               golang-github-gdamore-tcell.v2-dev,
+               golang-github-gdamore-tcell.v2-dev (>= 2.6.0),
                golang-github-maruel-natural-dev,
                golang-github-mattn-go-isatty-dev,
                golang-github-pbnjay-memory-dev,
-               golang-github-rivo-tview-dev (>= 0.0~git20210122),
+               golang-github-rivo-tview-dev (>= 0.0~git20230530.8bd761d),
                golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
                golang-github-stretchr-testify-dev,

=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,7 @@
 CGO_ENABLED := 0
 
 GO_LDFLAGS += -X '$(GOPKG)/build.Version=$(VERSION)'
-GO_LDFLAGS += -X '$(GOPKG)/build.User=debian' 
+GO_LDFLAGS += -X '$(GOPKG)/build.User=debian'
 GO_LDFLAGS += -X '$(GOPKG)/build.Time=$(shell TZ=Etc/UTC date +'%F_%T' -d @$(SOURCE_DATE_EPOCH))'
 
 %:

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%gdu-$1.tar.gz%,\
      uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/\$1~\$2\$3/" \
  https://github.com/dundee/gdu/tags .*/v?(\d\S*)\.tar\.gz debian
